/*******************************************************************
 *
 *	File:		ZoomAnim.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ZOOM_ANIM_H
#define __ZOOM_ANIM_H

#include <e32std.h>
#include <e32base.h>
#include <w32std.h>

#include "ZoomAnim_if.h"

#define ZOOM_ANIM_NAME _L("ZOOMANIM.DLL")

class RZoomAnim : public RAnim
{
public:
	RZoomAnim(){}
	RZoomAnim(RAnimDll &aAnimDll) : RAnim(aAnimDll){}
	TInt Construct(const RWindowBase &aDevice)
	{
		return RAnim::Construct(aDevice, 0, KNullDesC8);
	}
	TInt StartAnim(TInt aType)
	{
		TPckg<TInt> p(aType);
		return CommandReply(ZoomAnimCmdStart, p);
	}
	void StopAnim()
	{
		CommandReply(ZoomAnimCmdStop);
	}
	void ConfigureAnim(const TZoomAnimConfig& aZoomAnimConfig)
	{
		TPckg<TZoomAnimConfig> p(aZoomAnimConfig);
		CommandReply(ZoomAnimCmdConfigure, p);
	}
};


#endif			/* __ZOOM_ANIM_H */

