/*******************************************************************
 *
 *	File:		ControllerBase.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __CONTROLLER_BASE_H
#define __CONTROLLER_BASE_H

class CControllerBase : public CBase /*, public MFrameTickObserver*/
{
public:
	virtual TBool ModifyRawEvent(TRawEvent& aRawEvent) = 0;
	virtual TBool HandleKeyEvent(TInt aScanCode, TBool& aWantRepeat) = 0;
	virtual TBool HandlePointerDown(const TPoint& aPoint) = 0;
	virtual TBool HandlePointerUp(const TPoint& aPoint) = 0;
	virtual TBool HandlePointerMove(const TPoint& aPoint) = 0;

	virtual void Redraw(const TRect& aRect) = 0;
	virtual void Redraw() = 0;

	virtual void Start() = 0;
	virtual void Stop() = 0;
};

#endif			/* __CONTROLLER_BASE_H */
