/*******************************************************************
 *
 *	File:		FrameTicker.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __FRAME_TICKER_H
#define __FRAME_TICKER_H

class MFrameTickObserver
{
public:
	virtual void FrameTick() = 0;
};


class CFrameTicker : public CActive
{
public:
	enum {EBeforeDrawFrame, EDrawFrame, EAfterDrawFrame};
	~CFrameTicker();
	static CFrameTicker* NewL(TInt aFps);

	TInt Fps() {return iFps;}

		// either use start/stop or AddFrameTickObserver/RemoveFrameTickObserver
	void Start(MFrameTickObserver* aFrameTickObserver, TInt aAtWhatTime=EAfterDrawFrame);
	void Stop(MFrameTickObserver* aFrameTickObserver);

	void AddFrameTickObserver(MFrameTickObserver* aFrameTickObserver, TInt aAtWhatTime=EAfterDrawFrame);
	void RemoveFrameTickObserver(MFrameTickObserver* aFrameTickObserver);

protected:
	enum {KMaxObservers=4};
	CFrameTicker(TInt aFps);
	void ConstructL();
	void AddFrameTickObserver(MFrameTickObserver* aFrameTickObserver, MFrameTickObserver* aFrameTickerObservers[]);
	void RemoveFrameTickObserver(MFrameTickObserver* aFrameTickObserver, MFrameTickObserver* aFrameTickerObservers[]);


protected:		// from CActive
	void RunL();
	void DoCancel();

	MFrameTickObserver*			iBeforeFrameTickObservers[KMaxObservers];
	MFrameTickObserver*			iAfterFrameTickObservers[KMaxObservers];
	MFrameTickObserver*			iDrawFrameTickObservers[KMaxObservers];
	RTimer						iTimer;
	TTimeIntervalMicroSeconds32	iFrameDelay;
	TInt						iFps;
	TInt						iClientCount;
};


#endif			/* __FRAME_TICKER_H */
