/*******************************************************************
 *
 *	File:		InputManager.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __INPUT_MANAGER_H
#define __INPUT_MANAGER_H

#include "FrameTicker.h"
class CControllerBase;
class CFrameTicker;

class TInputManager : public MFrameTickObserver
{
public:
	TInputManager(){};
	TBool OfferRawEvent(const TRawEvent &aRawEvent);
	void SetFrameTicker(CFrameTicker* aFrameTicker){iFrameTicker = aFrameTicker;}
	void SetController(CControllerBase* aController){iController=aController;}
public:		// implements MFrameTickObserver
	virtual void FrameTick();
protected:
	enum{KMaxKeyRepeats = 8};
	class TKeyRepeat
	{
	public:
		TInt	iScanCode;
		TInt	iRepeatOnFrame;
	};

	TBool HasConsumedKeyDown(TInt aScanCode);
	void MarkKeyDown(TInt aScanCode, TBool aWantRepeat);

	void StartFrameTicker();
	void StopFrameTicker();

	TKeyRepeat				iRepeats[KMaxKeyRepeats];
	TInt					iFrame;
	CControllerBase*		iController;
	CFrameTicker*			iFrameTicker;
	TInt					iCount;
};


#endif			/* __INPUT_MANAGER_H */