/*******************************************************************
 *
 *	File:		ReadImage.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __READ_IMAGE_H
#define __READ_IMAGE_H

#include <e32base.h>
#include <mdaimageconverter.h>

class MReadImageObserver
{
public:
	virtual void ReadImageComplete(TInt aError) = 0;
};

class CReadImage : public CBase, public MMdaImageUtilObserver
{
public:
	~CReadImage();
	static CReadImage* NewL(const TSize& aSize, TBool aKeepRatio, TDisplayMode aDisplayMode, MReadImageObserver& aReadImageObserver);

	void ReadImage(const TDesC& aFilename);
	CFbsBitmap& Bitmap(){return *iBitmap;}

protected:	// implements MMdaImageUtilObserver
	void MiuoCreateComplete(TInt aError);
	void MiuoOpenComplete(TInt aError);
	void MiuoConvertComplete(TInt aError);

protected:
	CReadImage(const TSize& aSize, TBool aKeepRatio, TDisplayMode aDisplayMode, MReadImageObserver& aReadImageObserver);
	void ConstructL();
	void ConvertL();
	void ScaleL();

	CMdaImageFileToBitmapUtility* 	iConvertUtil;
	CMdaBitmapScaler*				iScaler;
	MReadImageObserver&				iReadImageObserver;
	TDisplayMode					iDisplayMode;
	CFbsBitmap*						iBitmap;
	TSize							iSize;
	TBool							iKeepRatio;
};


#endif			/* __READ_IMAGE_H */


