/*******************************************************************
 *
 *	File:		Zoom.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ZOOM_H
#define __ZOOM_H

#include <coecntrl.h>
#include <coeccntx.h>
#include <coemain.h>

#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>

#include "ezoom.hrh"
#include "zoomeng.h"

const TUid KUidZoomApp = { 0x101F6945 };

class CZoomDocument : public CEikDocument
{
public:
	~CZoomDocument();
	CZoomDocument(CEikApplication& aApp);
	void ConstructL();

private: // from CEikDocument
	CEikAppUi* CreateAppUiL();
};


class CZoomAppView : public CCoeControl, public MCoeControlBrushContext
{
public:
	~CZoomAppView();
	void ConstructL(const TRect& aRect);
private:
	void Draw(const TRect& /*aRect*/) const;
};


class CZoomAppUi : public CEikAppUi
{
public:
	CZoomAppUi(){}
	void ConstructL();
	~CZoomAppUi();

protected: // from CEikAppUi
	void HandleCommandL(TInt aCommand);
	void DynInitMenuPaneL(TInt aMenuId, CEikMenuPane* aMenuPane);
	void DynInitZoomMenuPaneL(CEikMenuPane* aMenuPane);

	void DisplayAboutDialogL();
	void DisplayOptionsDialogL();
	void DisplayHelpDialogL();

	void HandleWsEventL(const TWsEvent& aEvent, CCoeControl* aDestination);
	void NotificationReceived();
private:
	CZoomAppView*		iAppView;
	CZoomEngine*		iZoomEngine;
};



class CZoomApplication : public CEikApplication
	{
private: // from CApaApplication
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
	};

#endif			/* __ZOOM_H */

