/*******************************************************************
 *
 *	File:		ZoomEng.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ZOOM_ENG_H
#define __ZOOM_ENG_H

#include <e32def.h>
#include <e32base.h>
#include <w32std.h>

#include "ZoomAnim.h"

class TZoomOptions
{
public:
	TInt		iTransparency;
	TFileName	iBgImageFilename;
};


class CZoomEngine : public CBase
{
public:
	~CZoomEngine();
	static CZoomEngine*		NewL(RWsSession& aWsSession);

	void StartStopZooming();
	TBool IsZooming() {return iIsZooming;}

	const TZoomOptions&	Options() const {return iZoomOptions;}
	void SaveOptions(const TZoomOptions& aSCapOptions);

	TBool	ConsumeEvent(const TWsEvent& aEvent);

protected:
	CZoomEngine(RWsSession& aWsSession);
	TBool	IsBusy();

	void ConstructL();
	void LoadOptions();
	void DefaultOptions();

	void LoadAnimL();

	void ConfigureAnim();
	void StartZoomingL();
	void StartZooming();
	void StopZooming();

	CPeriodic*		iSystemActivityTimer;

	TZoomOptions	iZoomOptions;
	TBool			iIsZooming;

	RAnimDll		iAnimDll;
	RZoomAnim		iZoomAnim;
	TBool			iIsLoaded;

	RWsSession&		iWsSession;
	RWindowGroup	iWindowGroup;
	RWindow			iWindow;


	void DeregisterForNotifications();
	void RegisterForNotifications();
	TInt32			iNotifyScanCode;
	TInt32			iNotifyKeyCode;
};

#endif			/* __ZOOM_ENG_H */

