/*******************************************************************
 *
 *	File:		Zoom_ldd.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ZOOM_LDD_H
#define __ZOOM_LDD_H

#include <e32std.h>
#include <e32base.h>
#include <e32rom.h>

#include "zoom_ldd_if.h"


class RZoomDriver : public RBusLogicalChannel
{
public:
	inline TInt Open(const TVersion& aVer)	{return (DoCreate(LDD_NAME, aVer, NULL, KNullUnit, NULL, NULL));}
	
	inline TInt LinearToPhysical(TLinAddr aLinAddr, TPhysAddr* aPhysAddr) 
	{
		return DoControl(ZOOM_LDD_CMD_LIN_TO_PHYS, (TAny*)aLinAddr, aPhysAddr);
	}

	inline TInt RemapLinearAddr(TLinAddr aLinAddr, TPhysAddr aPhysAddr, TBool aCache, TBool aBuffer) 
	{
		zoom_cmd_remap_lin_addr_t	cmd = {aLinAddr, aPhysAddr, aCache, aBuffer};
		return DoControl(ZOOM_LDD_CMD_REMAP_LIN_ADDR, &cmd);
	}
};


#endif			/* __ZOOM_LDD_H */

